﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using BlogEngine.Core;
using BlogEngine.Core.Web.Controls;
using BlogEngine.Core.Web.Extensions;
using System.Collections.Generic;

namespace AreYouAHuman
{
    /// <summary>
    /// Summary description for AreYouAHuman
    /// </summary>
    [Extension("Settings for the AreYouAHuman CAPTCHA", "0.5", "<a href=\"http://thorarin.net/blog/\">Thorarin.NET</a>")]
    public class AreYouAHuman
    {
        private const string ExtensionName = "AreYouAHuman";

        private static readonly object _syncRoot = new object();

        /// <summary>
        /// Gets or sets the settings for each blog (identified with a Guid)
        /// </summary>
        private static readonly Dictionary<Guid, ExtensionSettings> _settings = new Dictionary<Guid, ExtensionSettings>();

        public AreYouAHuman()
        {
            GetSettings();
        }

        private ExtensionSettings GetSettings()
        {
            Guid blogId = Blog.CurrentInstance.Id;
            ExtensionSettings settings;

            lock (_syncRoot)
            {
                _settings.TryGetValue(blogId, out settings);

                if (settings == null)
                {
                    settings = new ExtensionSettings(ExtensionName) { IsScalar = true };

                    settings.AddParameter("PublisherKey", "Publisher Key", 50, true, true, ParameterType.String);
                    settings.AddValue("PublisherKey", "YOURPUBLISHERKEY");

                    _settings[blogId] = ExtensionManager.InitSettings(ExtensionName, settings);
                    ExtensionManager.SetStatus(ExtensionName, false);
                }
            }

            return settings;
        }
    }
}
